<!-- eslint-disable vue/no-side-effects-in-computed-properties -->
<script setup>
import DataList from "@components/Template/DataList.vue";
import { computed, ref } from "vue";
import { cloneDeep } from "lodash";

const props = defineProps({
  levels: { type: Array, required: true },
});
const emit = defineEmits(["levelSelect", "levelUpdate", "levelDelete"]);

const levelArray = computed(() => cloneDeep(props.levels));
const order = ref(true); // Up or Down
const sortBy = ref("name"); // name, modified or created
function sort(by) {
  sortBy.value = by;
  order.value = !order.value;
}
const sorted = computed(() => {
  let rv1 = 1;
  let rv2 = -1;
  if (order.value == false) {
    rv1 = -1;
    rv2 = 1;
  }
  switch (sortBy.value) {
    case "name":
      levelArray.value.sort((a, b) => {
        const nameA = a.name.toUpperCase();
        const nameB = b.name.toUpperCase();
        return nameA < nameB ? rv2 : nameA > nameB ? rv1 : 0;
      });
      break;
    case "modified":
      levelArray.value.sort((a, b) => {
        const modA = a.modified_at.toUpperCase();
        const modB = b.modified_at.toUpperCase();
        return modA < modB ? rv2 : modA > modB ? rv1 : 0;
      });
      break;
    case "created":
      levelArray.value.sort((a, b) => {
        const cA = a.created_at.toUpperCase();
        const cB = b.created_at.toUpperCase();
        return cA < cB ? rv2 : cA > cB ? rv1 : 0;
      });
      break;
  }
  return levelArray.value;
});
</script>

<template>
  <table class="table has-background-transparent is-bordered is-hoverable is-fullwidth">
    <thead>
      <tr>
        <th @click="sort('name')">
          <p class="is-flex is-align-items-center is-unselectable">
            Name
            <Icon :icon="sortBy == 'name' ? (order ? 'arrow-down' : 'arrow-up') : 'minus'" class="ml-2" />
          </p>
        </th>
        <th style="width: 25ch">Status/Comment</th>
        <th>Description</th>
        <th>Arguments</th>
        <th>Default</th>
        <th @click="sort('modified')">
          <p class="is-flex is-align-items-center is-unselectable">
            Modified
            <Icon :icon="sortBy == 'modified' ? (order ? 'arrow-down' : 'arrow-up') : 'minus'" class="ml-2" />
          </p>
        </th>
        <th @click="sort('created')">
          <p class="is-flex is-align-items-center is-unselectable">
            Created
            <Icon :icon="sortBy == 'created' ? (order ? 'arrow-down' : 'arrow-up') : 'minus'" class="ml-2" />
          </p>
        </th>
        <th class="has-no-outline"></th>
      </tr>
    </thead>
    <tbody>
      <tr v-for="level in sorted" :key="level.name">
        <td class="is-clickable">
          <button
            class="button p-0 is-primary is-fullwidth has-text-weight-semibold is-justify-content-flex-start"
            @click="emit('levelSelect', level.name)"
          >
            <Icon class="m-1 has-text-adaptor" :icon="'arrow-up-right'" />
            {{ level.name }}
          </button>
        </td>
        <td class="">
          <DataList
            :selection="level?.config?.status"
            :options="['done', 'work in progress', 'translate']"
            @selected="emit('levelUpdate', level.name, $event)"
          />
        </td>
        <td class="content is-small">{{ level?.config?.description }}</td>
        <td class="content is-small">
          {{ Object.keys(level?.config?.arguments).join(", ") }}
        </td>
        <td class="content is-small">
          {{ level.default?.item }}
          <br />
          {{ level.default?.plugin }}
        </td>
        <td class="content is-small">
          {{ level.modified_by }}
          <br />
          {{ new Date(level.modified_at).toDateString().replace("Invalid Date", "") }}
        </td>
        <td class="content is-small">
          {{ level.created_by }}
          <br />
          {{ new Date(level.created_at).toDateString().replace("Invalid Date", "") }}
        </td>
        <td class="has-no-outline pl-1">
          <div class="is-flex">
            <Icon class="m-1 has-text-adaptor" :icon="'arrow-up-right'" @click="emit('levelSelect', level.name)" />
            <Icon class="m-1" :icon="'trash-2'" @click.stop="emit('levelDelete', level.name)" />
          </div>
        </td>
      </tr>
    </tbody>
  </table>
</template>
